package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ExpressService;
import com.gxwebsoft.shop.entity.Express;
import com.gxwebsoft.shop.param.ExpressParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 物流公司记录表控制器
 *
 * @author 科技小王子
 * @since 2022-11-22 00:21:07
 */
@Api(tags = "物流公司记录表管理")
@RestController
@RequestMapping("/api/shop/express")
public class ExpressController extends BaseController {
    @Resource
    private ExpressService expressService;

    @PreAuthorize("hasAuthority('shop:express:list')")
    @OperationLog
    @ApiOperation("分页查询物流公司记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<Express>> page(ExpressParam param) {
        PageParam<Express, ExpressParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(expressService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(expressService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:express:list')")
    @OperationLog
    @ApiOperation("查询全部物流公司记录表")
    @GetMapping()
    public ApiResult<List<Express>> list(ExpressParam param) {
        PageParam<Express, ExpressParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(expressService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(expressService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:express:list')")
    @OperationLog
    @ApiOperation("根据id查询物流公司记录表")
    @GetMapping("/{id}")
    public ApiResult<Express> get(@PathVariable("id") Integer id) {
        return success(expressService.getById(id));
        // 使用关联查询
        //return success(expressService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:express:save')")
    @OperationLog
    @ApiOperation("添加物流公司记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Express express) {
        // 记录当前登录用户id、租户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          express.setUserId(loginUser.getUserId());
        }
        if (expressService.save(express)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:express:update')")
    @OperationLog
    @ApiOperation("修改物流公司记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Express express) {
        if (expressService.updateById(express)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:express:remove')")
    @OperationLog
    @ApiOperation("删除物流公司记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (expressService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:express:save')")
    @OperationLog
    @ApiOperation("批量添加物流公司记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Express> list) {
        if (expressService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:express:update')")
    @OperationLog
    @ApiOperation("批量修改物流公司记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Express> batchParam) {
        if (batchParam.update(expressService, "express_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:express:remove')")
    @OperationLog
    @ApiOperation("批量删除物流公司记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (expressService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
